use "io"
use "textio"
 use "htmlTokens.eh"
 use "strbuf"
 use "error"
 use "string"

type htmlTokenizer {
  last:Int,
  t:Int,
  buf:StrBuf,
  in:Reader }


 def parseTag(buf:String):htmlToken {
var i:Int=1 var tag:htmlToken=null var t:Int=0 var name:StrBuf=new StrBuf()
 
 if (buf[0] == '<' && buf[buf.len()-1] == '>') {
 
 if (buf[i] == '/') { t=1 i=2
  while(WHITE.indexof(buf[i]) != -1 ) i+=1
 while(WHITE.indexof(buf[i]) == -1 && buf[i] != '>') { name.addch(buf[i]) i+=1 }
 tag=new htmlCloseTag(name.tostr())
 while(WHITE.indexof(buf[i]) != -1 ) i+=1
 if (i != buf.len()-1 && buf[i] != '>') error(ERR_ILL_STATE,"Only tag name must be in a closing tag") }
 
 if (t==0 && buf.startswith("<!--")) { t=2
 if (!buf.endswith("-->")) error(ERR_ILL_ARG,"Comment tag must be closed by -->")
 else tag=new htmlComment(buf[4:buf.len()-3].trim()) }
 
 if (t == 0 && buf.startswith("<!DOCTYPE")) { t=3
  tag=new htmlDocType(buf[10:buf.len()-1].trim()) }
 
 
 if ( t==0) {  t=4 var attr:Dict
 /*skip*/ while(WHITE.indexof(buf[i]) != -1 ) i+=1
  while(WHITE.indexof(buf[i]) == -1 && buf[i] != '>' && buf[i] != '/') { name.addch(buf[i]) i+=1 }
  /*skip*/ while(WHITE.indexof(buf[i]) != -1 ) i+=1
 
 var end:Bool=false
 
 if (buf[i] == '>' || buf[i] == '/') end=true
 
 if (end) attr=null else attr=new Dict()
 
 while(!end) { var key:StrBuf=new StrBuf() var val:StrBuf=new StrBuf()
 while (WHITE.indexof(buf[i]) == -1 && buf[i] != '=') {  key.addch(buf[i]) i+=1  }
 if (buf[i] != '=') while(WHITE.indexof(buf[i]) != -1 ) i+=1
 if (buf[i] != '=') error(ERR_ILL_ARG,"The attribute value must be specified with an equal(=) sign")
 i+=1
   /*skip*/ while(WHITE.indexof(buf[i]) != -1 ) i+=1
 if (buf[i] != '\'' && buf[i] != '\"') error(ERR_ILL_ARG,"Attribute value must be specified within single or double quotes")
 var s=buf[i] i+=1
 while (buf[i] != s) { val.addch(buf[i]) i+=1 }
 attr[key.tostr()]=val.tostr()
 i+=1
  /*skip*/ while(WHITE.indexof(buf[i]) != -1 ) i+=1
 if (buf[i] == '/' || buf[i] == '>') end = true
 } //while
 if(buf[i]=='/' && i == buf.len()-2) tag=new htmlSelfClose(name.tostr(),attr)
  if(buf[i]=='>' && i == buf.len()-1) tag = new htmlStartTag(name.tostr(),attr)
  } //t=4

 }  
 else error(ERR_ILL_ARG,"Tags must be enclosed within angular brackets")
 if (t==0 || tag == null) error(FAIL,"Some unknown error occurred during parsing")
 tag
 }
 
 def parseText(buf:String):htmlText {
 
 new htmlText(buf)
 }


def htmlTokenizer.new(r:Reader) { this.in=r this.last=0 this.buf=new StrBuf() this.t=0 } 
 
 def htmlTokenizer.next():htmlToken {
 if (this.last == 0 ) this.last=this.in.read()
 
 while(WHITE.indexof(this.last.cast(Char)) != -1) this.last=this.in.read()
 
 switch (this.last) {
  '<'.cast(Int) : this.t = 1;
 -1: this.t = 3; 
 else : this.t=2;
 }

switch (this.t) {
 1: { do {  this.buf.addch(this.last.cast(Char)) this.last=this.in.read()   if (this.last == '<'.cast(Int)) error(ERR_ILL_ARG, "An html tag must be closed before another is opened" + this.buf.tostr()) } while(this.last != -1 && this.last != '>'.cast(Int)) if (this.last == '>'.cast(Int)) { this.buf.addch('>') this.last=this.in.read() } else error(ERR_ILL_STATE,"EOF encountered when a tag is opened") }
 2: { while (this.last != -1 && this.last != '<'.cast(Int)) { this.buf.addch(this.last) this.last=this.in.read() } if (this.last == -1) error(ERR_ILL_STATE,"Html document is ending with a text element") }
 }
 
var tag:htmlToken 
 
 switch(this.t) {
 2: tag = parseText(this.buf.tostr())
  1: tag = parseTag(this.buf.tostr())
 3: tag = new htmlEOF()
   }
  this.buf =new StrBuf()
 tag
 }
 

