use "io"
use "dict"
 
const WHITE=" \n\t\r" 
 const HTML_DOCTYPE=0
 const HTML_START_TAG=1
 const HTML_CLOSE_TAG=2
 const HTML_SELF_CLOSE=3
 const HTML_TEXT=4
 const HTML_COMMENT=5
 const HTML_EOF=6

type htmlToken;
 def htmlToken.new(t:Int);
 def htmlToken.get_typ():Int;
 def htmlToken.tostr():String;
 
 type htmlStartTag < htmlToken;
 
def htmlStartTag.new(name:String, attr:Dict=null);
 def htmlStartTag.get_name():String;
def htmlStartTag.get(key:String);
def htmlStartTag.set(key:String, value:String);
 def htmlStartTag.remove(key:String);
 def htmlStartTag.clear();
 def htmlStartTag.size():Int;
  def htmlStartTag.tostr():String;

 type htmlCloseTag < htmlToken;
 def htmlCloseTag.new(name:String);
 def htmlCloseTag.get_name():String;
  def htmlCloseTag.tostr():String;
 
 type htmlSelfClose < htmlToken;
 
 def htmlSelfClose.new(name:String, attr:Dict=null);
 def htmlSelfClose.get_name():String;
 def htmlSelfClose.get(key:String);
 def htmlSelfClose.set(key:String, value:String);
 def htmlSelfClose.remove(key:String);
 def htmlSelfClose.clear();
 def htmlSelfClose.size():Int;
  def htmlSelfClose.tostr():String;
 
 type htmlDocType < htmlToken;
 def htmlDocType.new(decl:String);
 def htmlDocType.get_decl():String;
  def htmlDocType.tostr():String;
 
 type htmlComment < htmlToken;
 def htmlComment.new(info:String);
 def htmlComment.get_info():String;
  def htmlComment.tostr():String;
 
 type htmlText < htmlToken;
 def htmlText.new(text:String);
 def htmlText.get_text():String;
  def htmlText.tostr():String;
 
 type htmlEOF < htmlToken;
 def htmlEOF.new();
